function createTextSignDatablocks()
{
	%pattern = "Add-Ons/Print_Letters_Default/prints/*.png";
	
	for( %file = findFirstFile(%pattern); %file !$= ""; %file = findNextFile(%pattern) )
	{
		%name = fileName(%file);
		%name = strreplace(%name, ".png", "");
		%name = strreplace(%name, "-", "");
	
		%eval = "datablock ParticleData(TS_Particle"@%name@"){textureName=\""@%file@"\";dragCoefficient=0;gravityCoefficient=0;inheritedVelFactor=0;windCoefficient=1;constantAcceleration=3;lifetimeMS=800;lifetimeVarianceMS=0;spinSpeed=0;spinRandomMin=0;spinRandomMax=0;useInvAlpha=true;colors[0]=\"1 1 1 1\";colors[1]=\"1 1 1 1\";sizes[0]=0.6;sizes[1]=0.6;sizes[2]=0.6;sizes[3]=0.6;times[0]=1.0;times[1]=0.9;times[2]=0.1;};datablock ParticleEmitterData(TS_Emitter"@%name@"){particles=TS_Particle"@%name@";ejectionPeriodMS=300;periodVarianceMS=0;ejectionVelocity=0;ejectionOffset=0;velocityVariance=0.0;thetaMin=0;thetaMax=0;phiReferenceVel=0;phiVariance=0;overrideAdvance=false;orientParticles=false;};";
		eval(%eval);
	}

	$createdTextSignDatablocks = true;
}

function getTextSignName(%this)
{
	switch$( %this )
	{
		case "&":
			%this = "and";
		case "'":
			%this = "apostrophe";
		case "*":
			%this = "asterisk";
		case "@":
			%this = "at";
		case "!":
			%this = "bang";
		case "^":
			%this = "caret";
		case "$":
			%this = "dollar";
		case "=":
			%this = "equals";
		case ">":
			%this = "greater_than";
		case "<":
			%this = "less_than";
		case "-":
			%this = "minus";
		case "%":
			%this = "percent";
		case ".":
			%this = "period";
		case "+":
			%this = "plus";
		case "#":
			%this = "pound";
		case "?":
			%this = "qmark";
	}

	return %this;
}

function createTextSignParticle(%name, %pos)
{
	%name = getTextSignName(%name);

	%db = "TS_Emitter" @ %name;

	if( !isObject(%db) || %pos $= "" )
	{
		return;
	}

	%this = new ParticleEmitterNode()
	{
		position = %pos;
		rotation = "1 0 0 0";
		scale = "0.05 0.05 0.05";
		dataBlock = "GenericEmitterNode";
		emitter = %db;
		velocity = "1";
	};

	MissionCleanup.add(%this);
}

function createTextSign(%text, %pos)
{
	if(%text $= "" || %pos $= "")
	{
		return;
	}

	%len = strlen(%text);

	%x = getWord(%pos, 0);
	%x -= (%len * 0.25);

	%yz = getWords(%pos, 1, 2);

	for(%i = 0; %i < %len; %i++)
	{
		%l = getSubStr(%text, %i, 1);

		createTextSignParticle(%l, %x SPC %yz);

		%x += 0.5;
	}
}

if(!$createdTextSignDatablocks)
{
	createTextSignDatablocks();
}